module ForteRuby
  module API
    class Object < Base

      attr_accessor :new

      def delete
        send_request(url, :delete)
      end

      def update(params)
        set_attributes(params)
        save
      end

      def save
        method_name = new? ? :post : :put

        result = send_request(url, method_name, api_attributes_hash)

        if result.successful? && new?
          set_attributes(result.response.merge(new: false))
        end

        result
      end

      protected

      def url
        raise 'Impelement it'
      end
      
      def api_attributes
        raise 'Impelement it'
      end

      private

      def api_attributes_hash
        api_attributes.inject({}) do |hash, element|
          hash[element] = self.send(element)
          hash
        end
      end

      def new?
        new
      end
    end
  end
end
