module ForteRuby
  module Resourses
    class Transaction < API::Object
      
      API_ATTRIBUTES = [
        :action, :one_time_token, :customer_token, :customer_id, :paymethod_token, :reference_id, :authorization_amount, :order_number,
        :original_transaction_id, :transaction_id, :authorization_code, :software_name, :entered_by, :received_date, :origination_date,
        :customer_accounting_code, :sales_tax_amount, :service_fee_amount, :sec_code, :billing_address, :shipping_address, :paymethod
      ]

      API_ATTRIBUTES.each do |attribute|
        attr_accessor attribute
      end

      def delete
        raise 'It is not implemented'
      end

      def update
        raise 'It is not implemented'
      end

      def save
        raise 'It is not implemented'
      end

      protected
      
      def api_attributes
        API_ATTRIBUTES
      end
    end
  end
end
