require "forte_ruby/version"
require "forte_ruby/api/base"
require "forte_ruby/api/objects"
require "forte_ruby/api/object"
require "forte_ruby/api/request_data"
require "forte_ruby/resourses/customers"
require "forte_ruby/resourses/customer"
require "forte_ruby/resourses/addresses"
require "forte_ruby/resourses/address"
require "forte_ruby/resourses/transactions"
require "forte_ruby/resourses/transaction"
require "forte_ruby/resourses/settlements"
require "forte_ruby/resourses/settlement"

module ForteRuby
  def self.customers
    ForteRuby::Resourses::Customers.new
  end

  def self.transactions
    ForteRuby::Resourses::Transactions.new
  end

  def self.settlements
    ForteRuby::Resourses::Settlements.new
  end

  def self.config
    ForteRuby::API::RequestData.new.config
  end
end
