module ForteRuby
  module Resourses
    class Addresses < API::Objects

      attr_accessor :customer_token

      def build_from(params)
        single_class.new(params.merge(request_data: request_data, new: true, customer_token: customer_token))
      end

      protected

      def single_class
        Address
      end

      def url
        "#{request_data.base_url}/customers/#{customer_token}/addresses"
      end
    end
  end
end
